#Register SDE Raster Layer to GeoServer
#author: Hubert Asamer 2012
import arcpy, os, sys, string
import subprocess

inputFeatures = string.split(string.replace(arcpy.GetParameterAsText(0),"\'",""), ";")
sld_file = arcpy.GetParameterAsText(1)
gs_host = arcpy.GetParameterAsText(2)
gs_user = arcpy.GetParameterAsText(3)
gs_pw = arcpy.GetParameterAsText(4)
gs_workspace = arcpy.GetParameterAsText(5)
sdeusername=arcpy.GetParameterAsText(6)
sdepassword=arcpy.GetParameterAsText(7)
sdehost=arcpy.GetParameterAsText(8)
sdeport=arcpy.GetParameterAsText(9)

for name in inputFeatures:
    featureClassName = name.upper()
    arcpy.AddMessage(featureClassName)
    p = subprocess.Popen(['curl', '-XPOST', '-u', ''+gs_user+':'+gs_pw+'', '-H', 'Content-Type:text/xml', '-d', '<coverageStore><name>'+featureClassName+'</name><type>ArcSDE Raster</type><enabled>true</enabled><url>sde://'+sdeusername+':'+sdepassword+'@'+sdehost+':'+sdeport+'/#'+featureClassName+'</url></coverageStore>', 'http://'+gs_host+'/rest/workspaces/'+gs_workspace+'/coveragestores'], shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    for line in p.stdout.readlines():
        arcpy.AddMessage(line),
    retval = p.wait()
    q = subprocess.Popen(['curl', '-XPOST', '-u', ''+gs_user+':'+gs_pw+'', '-H', 'Content-Type:text/xml', '-d', '<coverage><name>'+featureClassName+'</name><nativeFormat>ArcSDE Raster</nativeFormat><nativeCRS>EPSG:4326</nativeCRS><srs>EPSG:900913</srs><parameters><entry><string>OVERVIEW_POLICY</string><string>QUALITY</string></entry></parameters></coverage>', 'http://'+gs_host+'/rest/workspaces/'+gs_workspace+'/coveragestores/'+featureClassName+'/coverages'], shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    for line1 in q.stdout.readlines():
        arcpy.AddMessage(line1),
    retval = q.wait()
    
   
    
    

