#Register SDE Vector Layer to GeoServer
#author: Hubert Asamer 2012
import arcpy, os, sys, string
import subprocess

inputFeatures = string.split(string.replace(arcpy.GetParameterAsText(0),"\'",""), ";")
sld_file = arcpy.GetParameterAsText(1)
gs_host = arcpy.GetParameterAsText(2)
gs_user = arcpy.GetParameterAsText(3)
gs_pw = arcpy.GetParameterAsText(4)
gs_workspace = arcpy.GetParameterAsText(5)
gs_store =arcpy.GetParameterAsText(6)

for name in inputFeatures:
    featureClassName = name.upper()
    arcpy.AddMessage(featureClassName)
    p = subprocess.Popen(['curl',
    '-XPOST','-u',''+gs_user+':'+gs_pw+'', '-d',
    '{"featureType":{"name":"'+featureClassName+'","nativeCRS":"EPSG:4326","srs":"EPSG:900913","projectionPolicy":"REPROJECT_TO_DECLARED"}}',
    '-H', 'Content-Type:application/json',
    'http://'+gs_host+'/rest/workspaces/'+gs_workspace+'/datastores/'+gs_store+'/featuretypes'],
    shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    for line in p.stdout.readlines():
        arcpy.AddMessage(line),
    retval = p.wait()
