#Register SDE Vector Layer to GeoServer
#author: Hubert Asamer 2012
import arcpy, os, sys, string
import subprocess

inputFeatures = string.split(string.replace(arcpy.GetParameterAsText(0),"\'",""), ";")
sld_file = os.path.abspath(arcpy.GetParameterAsText(1))
gs_host = arcpy.GetParameterAsText(2)
gs_user = arcpy.GetParameterAsText(3)
gs_pw = arcpy.GetParameterAsText(4)
gs_workspace = arcpy.GetParameterAsText(5)

for name in inputFeatures:
    featureClassName = name.upper()
    arcpy.AddMessage(featureClassName)
    arcpy.AddMessage(sld_file)
    p = subprocess.Popen(['curl','-XPOST','-u',''+gs_user+':'+gs_pw+'','-d','<style><name>'+featureClassName+'</name><filename>'+featureClassName+''+'.'+'sld</filename></style> ','-H','Content-Type: text/xml',
    'http://'+gs_host+'/rest/styles'], shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    for line in p.stdout.readlines():
        arcpy.AddMessage(line),
    retval = p.wait()
    arcpy.AddMessage('Style created!')
    q = subprocess.Popen(['curl', '-XPUT', '-u', ''+gs_user+':'+gs_pw+'', '-d', '@'+sld_file, '-H', 'Content-Type:application/vnd.ogc.sld+xml', 'http://'+gs_host+'/rest/styles/'+string.replace(featureClassName,".","%2E")+''], shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    for line1 in q.stdout.readlines():
        arcpy.AddMessage(line1),
    retval = q.wait()
    arcpy.AddMessage('SLD-File uploaded!')
    r = subprocess.Popen(['curl','-XPUT','-u',''+gs_user+':'+gs_pw+'','-d','<layer><defaultStyle><name>'+featureClassName+'</name></defaultStyle><enabled>true</enabled></layer> ','-H','Content-Type: text/xml',
    'http://'+gs_host+'/rest/layers/'+gs_workspace+':'+string.replace(featureClassName,".","%2E")], shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    for line2 in r.stdout.readlines():
        arcpy.AddMessage(line2),
    retval = r.wait()
    arcpy.AddMessage('Style linked with layer!')
    
    

